unit Unit1;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, NicePreview, ComCtrls, {Series, TeEngine,
  TeeProcs,} Chart;

type
  TForm1 = class(TForm)
    NicePreview1: TNicePreview;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    StatusBar1: TStatusBar;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    TabControl1: TTabControl;
    Chart1: TChart;
    Series1: TFastLineSeries;
    Series2: TBarSeries;
    Series3: TFastLineSeries;
    Button9: TButton;
    Button10: TButton;
    procedure NicePreview1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure RenderTexts;
    procedure RenderGrids;
    procedure RenderGraphs;
    procedure RenderGraphics;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure TForm1.NicePreview1Change(Sender: TObject);
begin
  StatusBar1.Panels[0].Text := 'Page ' + IntToStr(NicePreview1.PageIndex + 1) +
    ' of ' + IntToStr(NicePreview1.PageCount);
  StatusBar1.Panels[1].Text := 'Magnification ' + IntToStr(Round(NicePreview1.Magnification * 100)) + '%';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  NicePreview1.PreviewMode := pmNormal;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  NicePreview1.PreviewMode := pmZoomIn;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  NicePreview1.PreviewMode := pmZoomOut;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  NicePreview1.PreviewMode := pmDrag;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  NicePreview1.ViewActualSize;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  NicePreview1.ViewFitToWidth;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  NicePreview1.ViewWholePage;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  NicePreview1.ViewTwoPage;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  NicePreview1.ViewFourPage;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  x: Integer;
begin
  RenderTexts;

  Series1.Clear;
  Series2.Clear;
  Series3.Clear;

  for x := 1 to 10 do
  begin
    Series1.AddXY(x, Random(200), IntToStr(x));
    Series2.AddXY(x, Random(200), IntToStr(x));
    Series3.AddXY(x, Random(200), IntToStr(x));
  end;

end;

procedure TForm1.RenderTexts;
var
  ACanvas: TCanvas;
  h: Integer;
  th: Integer;
  i, j: Integer;
  t: TStringList;

begin

  NicePreview1.Clear;

  t := TStringList.Create;
  try
    t.LoadFromFile('..\License.txt');
  except
    ShowMessage('File ..\License.txt doesn''t exist. Unable to render preview.'#13 +
      'If you run this file from ZIP extractor program, extract all files first and rerun.');
  end;

  if (t.Count = 0) then
  begin
    t.Free;
    Exit;
  end;

  with NicePreview1 do
  begin
    th := PageHeight - MarginTop - MarginBottom;
  end;

  i := 0;
  j := -1;
  h := 0;
  ACanvas := nil;

  repeat

    if (j < h) then
    begin
      if (ACanvas <> nil)
        then NicePreview1.EndPage;
      ACanvas := NicePreview1.BeginPage;
      with ACanvas do
      begin
        Font.Name := 'Lucida Console';
        Font.Size := 8;
        h := TextHeight('Ag');
      end;
      j := th;
    end;

    ACanvas.TextOut(NicePreview1.MarginLeft, NicePreview1.MarginTop + (th - j), t[i]);

    Inc(i);
    Dec(j, h);

  until (i >= t.Count);

  NicePreview1.EndPage;

  t.Free;

end;

procedure TForm1.RenderGraphics;
const
  Str1 = 'Looks Familiar?';
  Str2 = 'This is copy of your desktop window!';

var
  Bmp: TBitmap;
  DeskDC: HDC;
  DeskWnd: HWND;
  w, h: Integer;
  x, y: Integer;

begin
  Bmp := TBitmap.Create;

  with NicePreview1 do
  begin
    w := PageWidth - MarginLeft - MarginRight;
    h := Round((w / Screen.DesktopWidth) * Screen.DesktopHeight);
    x := (PageWidth - w) div 2;
    y := (PageHeight - h) div 2;
  end;

  Bmp.Width := w;
  Bmp.Height := h;

  DeskWnd := GetDesktopWindow;
  DeskDC := GetDC(DeskWnd);
  StretchBlt(Bmp.Canvas.Handle, 0, 0, w, h,
    DeskDC, 0, 0, Screen.DesktopWidth, Screen.DesktopHeight, SRCCOPY);
  ReleaseDC(DeskWnd, DeskDC);


  NicePreview1.Clear;
  with NicePreview1.BeginPage, NicePreview1 do
  begin
    Draw(x, y, Bmp);

    Font.Name := 'Courier New';
    Font.Size := 18;
    Font.Style := [];
    Font.Color := clRed;
    w := TextWidth(Str2);
    h := TextHeight(Str2);
    x := (PageWidth - w) div 2;
    y := y - 50 - h;
    TextOut(x, y, Str2);

    Font.Name := 'Arial';
    Font.Size := 24;
    Font.Style := [fsBold];
    Font.Color := clBlack;
    w := TextWidth(Str1);
    h := TextHeight(Str1);
    x := (PageWidth - w) div 2;
    y := y - 5 - h;
    TextOut(x, y, Str1);

  end;
  NicePreview1.EndPage;



  Bmp.Free;
end;

procedure TForm1.RenderGraphs;
const
  Str1 = 'TeeChart with Texts';
  Str2 = 'Really nice, isn''t it?';

var
  wmf: TMetafile;
  x, y: Integer;
  w, h: Integer;

begin
  Chart1.SaveToMetafileEnh('dummy.wmf');
  wmf := TMetafile.Create;
  wmf.LoadFromFile('dummy.wmf');

  with NicePreview1 do
  begin
    Clear;
    with BeginPage do
    begin

      w := PageWidth - MarginLeft - MarginRight;
      h := Round((w / Wmf.Width) * Wmf.Height);
      x := (PageWidth - w) div 2;
      y := (PageHeight - h) div 2;
      StretchDraw(Rect(x, y, x + w, y + h), Wmf);

      Font.Name := 'Courier New';
      Font.Size := 18;
      Font.Style := [];
      Font.Color := clRed;
      w := TextWidth(Str2);
      h := TextHeight(Str2);
      x := (PageWidth - w) div 2;
      y := y - 50 - h;
      TextOut(x, y, Str2);

      Font.Name := 'Arial';
      Font.Size := 24;
      Font.Style := [fsBold];
      Font.Color := clBlack;
      w := TextWidth(Str1);
      h := TextHeight(Str1);
      x := (PageWidth - w) div 2;
      y := y - 5 - h;
      TextOut(x, y, Str1);

    end;
    EndPage;
  end;

  Wmf.Free;
end;

procedure TForm1.RenderGrids;
const
  Str1 = 'This is a grid test.';
  Str2 = 'All like drawing on ordinary screen canvas.';
var
  x, y, w, h: Integer;
  R: TRect;
  ax, ay: Integer;
  DeltaX: Integer;
  
begin

  NicePreview1.Clear;

  with NicePreview1.BeginPage do
  begin

    Font.Name := 'Arial';
    Font.Size := 24;
    Font.Style := [fsBold];
    Font.Color := clBlack;
    w := TextWidth(Str1);
    h := TextHeight(Str1);
    x := (NicePreview1.PageWidth - w) div 2;
    y := NicePreview1.MarginTop;
    TextOut(x, y, Str1);
    y := y + h + 5;

    Font.Name := 'Courier New';
    Font.Size := 16;
    Font.Style := [];
    Font.Color := clRed;
    w := TextWidth(Str2);
    h := TextHeight(Str2);
    x := (NicePreview1.PageWidth - w) div 2;
    TextOut(x, y, Str2);
    y := y + h + 30;

    Font.Name := 'Arial';
    Font.Size := 8;
    Font.Style := [];
    Font.Color := clBlack;
    w := (NicePreview1.PageWidth - NicePreview1.MarginLeft - nicePreview1.MarginRight) div 10;
    h := TextHeight('Ag') + 3;
    DeltaX := (NicePreview1.PageWidth - (w * 10)) div 2;
    Brush.Style := bsClear;

    for ax := 0 to 9 do
    begin
      for ay := 0 to 29 do
      begin
        R := Rect(ax * w, ay * h, ((ax + 1) * w) + 1, ((ay + 1) * h) + 1);
        OffsetRect(R, DeltaX, y);
        Brush.Style := bsSolid;
        Rectangle(R);
        Brush.Style := bsClear;
        TextRect(R, R.Left + 5, R.Top + 3, IntToStr(ax) + ',' + IntToStr(ay));
      end;
    end;

  end;

  NicePreview1.EndPage;

end;

procedure TForm1.TabControl1Change(Sender: TObject);
begin
  case TabControl1.TabIndex of
    0: RenderTexts;
    1: RenderGrids;
    2: RenderGraphs;
    3: RenderGraphics;
  else
    NicePreview1.Clear;
  end;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  NicePreview1.PrintAll;
end;

end.
